<?
class flowofdocuments {
	
	public $nc_core;
	public $Catalogue_ID;
	public $Subdivision_ID;
	public $Sub_Class_ID;
	public $Class_ID;
	public $Message_ID;
	public $Component_ID;
	
	
	
	public function __construct () {
		
		$this->nc_core = nc_Core::get_object();
		
		$this->nc_core->event->bind($this, array('addCatalogue' => '_addCatalogue') );
		
		$this->nc_core->event->bind($this, array('addMessage' => '_addMessage') );
		
		$this->nc_core->event->bind($this, array('updateMessage' => '_updateMessage') );
		
		$this->nc_core->event->bind($this, array('dropMessage' => '_dropMessage') );
		
	}
	
	public function  _addCatalogue($Catalogue_ID) {
		
		
		
		
		$res=$this->nc_core->db->get_row("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='Component_ID'",ARRAY_A);
		$Component_ID=$res['Value'];
		
		
		
		$res_sub=$this->nc_core->db->query("
			INSERT INTO Subdivision SET
			Subdivision_Name='Документооборот',
			Catalogue_ID=".$Catalogue_ID.",
			EnglishName='flowofdocuments".$Catalogue_ID."',
			Hidden_URL='flowofdocuments".$Catalogue_ID."'
		",ARRAY_A);
		
		
		
		if ($res_sub){
			$res_sub_id=$this->nc_core->db->get_row("SELECT Subdivision_ID FROM Subdivision WHERE Catalogue_ID=".$Catalogue_ID." AND Subdivision_Name='Документооборот' AND EnglishName='flowofdocuments".$Catalogue_ID."'",ARRAY_A);
			
			if ($res_sub_id){
				
				$res_sub_class=$this->nc_core->db->query("
					INSERT INTO Sub_Class SET
					Subdivision_ID=".$res_sub_id['Subdivision_ID'].",
					Class_ID=".$Component_ID.",
					Sub_Class_Name='Документооборот',
					EnglishName='flowofdocuments".$Catalogue_ID."',
					Catalogue_ID=".$Catalogue_ID."
				",ARRAY_A);
				
			}
		}
		
		
		
		
		
		
	}
	
	public function  _dropMessage($Catalogue_ID, $Subdivision_ID, $Sub_Class_ID, $Class_ID, $Message_ID) {
		
		
		
		$res=$this->nc_core->db->get_row( "SELECT MAX(ID)  max_id FROM FlowOfDocuments WHERE Message_ID=".$this->Message_ID." AND Class_ID=".$this->Class_ID."");
		$this->nc_core->db->query("UPDATE FlowOfDocuments SET Action='drop' WHERE Message_ID=".$this->Message_ID." AND  Class_ID=".$this->Class_ID." AND ID=".$res['max_id']." ");
		
		
		
	}

	public function  _updateMessage($Catalogue_ID, $Subdivision_ID, $Sub_Class_ID, $Class_ID, $Message_ID) {
		
		
		$this->Catalogue_ID=$Catalogue_ID;
		$this->Subdivision_ID=$Subdivision_ID;
		$this->Sub_Class_ID=$Sub_Class_ID;
		$this->Class_ID=$Class_ID;
		$this->Message_ID=$Message_ID;
		
		
		
		$this->addAction('update');
		
		return true;
		
	}
	
	public function  _addMessage($Catalogue_ID, $Subdivision_ID, $Sub_Class_ID, $Class_ID, $Message_ID) {
		
		$this->Catalogue_ID=$Catalogue_ID;
		$this->Subdivision_ID=$Subdivision_ID;
		$this->Sub_Class_ID=$Sub_Class_ID;
		$this->Class_ID=$Class_ID;
		$this->Message_ID=$Message_ID;
		
		$this->addAction('add');
		
		
		
	}
	function addAction($action){
		
		
		$res = $this->nc_core->db->get_results("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='SubClass' AND Value='".$this->Sub_Class_ID."'", ARRAY_A);
		
		
		if (!$res){
			return true;
		}
		
		
		
		
		$res=$this->nc_core->db->get_row("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='Component_ID'",ARRAY_A);
		if (!$res){
			return true;
		}
		
		$this->Component_ID['Class_ID']=$res['Value'];
		
		
		
		
		$res=$this->nc_core->db->get_row("SELECT Sub_Class_ID, Subdivision_ID  FROM Sub_Class WHERE Class_ID=".$this->Component_ID['Class_ID']." AND Catalogue_ID=".$this->Catalogue_ID,ARRAY_A);
		$this->Component_ID['Sub_Class_ID']=$res['Sub_Class_ID'];
		$this->Component_ID['Subdivision_ID']=$res['Subdivision_ID'];
				
		
		
		$res = $this->nc_core->db->get_results("SELECT Field_Name,Format,Field_ID,TypeOfData_ID FROM Field  WHERE Class_ID=".$this->Class_ID."",ARRAY_A);
		
		$arr_file=array();
		
		foreach ($res as $val){
			
			
			$arr_fields[$val['Field_Name']]="`".$val['Field_Name']."`";
			
			if ($val['TypeOfData_ID']==6)
				$arr_file[$val['Field_Name']]=$val;
			
			if ($val['TypeOfData_ID']==11)
				$arr_multi_file[$val['Field_Name']]=$val;
			
		}
			
		if (count($arr_file)>0||count($arr_multi_file)) {
			$copyFile = new copyFile();
		}
		
		
		$res=$this->nc_core->db->get_row("SELECT Message_ID, ".implode(",",$arr_fields).",LastUser_ID,LastUserAgent,LastIP,Sub_Class_ID, Subdivision_ID  FROM Message".$this->Class_ID." WHERE Message_ID=".$this->Message_ID,ARRAY_A);
		
		foreach ($res as $k=>$v){
			
			if (!$arr_fields[$k]){
			
				$in['Utilities'][$k]=$v;
				
			}
			else{
				
				if ($arr_file[$k]){
			
					
					if ($v)
						$v=$copyFile->action($arr_file[$k],$v,$this->Message_ID,$this->Subdivision_ID,$this->Sub_Clas_ID);
					
				}
				elseif($arr_multi_file[$k]){
					
					$v=$copyFile->action_multi($arr_multi_file[$k],$v,$this->Message_ID,$this->Subdivision_ID,$this->Sub_Clas_ID);
				
				}
				
				$in['User'][$k]=$v;
				
			}
		
		}
		
		$in['Utilities']['Class_ID']=$this->Class_ID;
		
		$this->nc_core->db->query("
			INSERT INTO 
				Message".$this->Component_ID['Class_ID']." 
			SET 
				SubClass=".$this->Sub_Class_ID.", 
				Sub_Class_ID=".$this->Component_ID['Sub_Class_ID'].", 
				Subdivision_ID=".$this->Component_ID['Subdivision_ID'].", 
				DATA='".mysql_real_escape_string(serialize($in))."',
				Date=Now()"
				);
		
		return true;
		
	}
	
	
}



class copyFile{
	
	public $nc_core;
	
	public function action($Field_Line,$User_Info,$MID,$SID,$CLID){
		
		
		$this->nc_core = nc_Core::get_object();
	
	/*
		fs1:inline  простой
		fs2:inline стандартный
		fs3:inline защищиенный
		fs3:attachment защищенный, загружаемый

	*/
		
		
		$newnamefile=md5(microtime());
		
		
		
		if ($Field_Line['Format']=='fs3:inline'||$Field_Line['Format']=='fs3:attachment'){
			
			
			
			$res = $this->nc_core->db->get_row("SELECT * FROM FileTable WHERE Field_ID=".$Field_Line['Field_ID']." AND Message_ID=".$MID."",ARRAY_A);
			
						
			
			$curfile=$this->nc_core->DOCUMENT_ROOT."/netcat_files".$res['File_Path'].$res['Virt_Name'];
			
			if (!file_exists($curfile)){
				return array(
					'error'=>'исходного файла не существует'
				);
			}
			
			
			
			copy($curfile,$this->nc_core->DOCUMENT_ROOT."/netcat_files".$res['File_Path'].$newnamefile);
			
			$simple_file_path=substr($res['File_Path'],1,strlen($res['File_Path']));
			
			return array(
				
				'Protected'=>1,
				'Format'=>$Field_Line['Format'],
				'Original'=>array(
					'User_Info'=>$User_Info,
					'Field_File'=>$res,
					'File_Name'=>$res['Virt_Name'],
					'File_Path'=>$simple_file_path
				),
				'Copy'=>array(
					'File_Name'=>$newnamefile,
					'File_Path'=>$simple_file_path
				),
				'Simple1'=>array(
					'User_Info'=>$User_Info,
					'Field_File'=>'',
					'File_Name'=>$res['Real_Name'],
					'File_Path'=>$simple_file_path
					
				),
				'Simple2'=>array(
					'User_Info'=>$User_Info.":".$simple_file_path.$res['Virt_Name'],
					'Field_File'=>'',
					'File_Name'=>$Field['Real_Name'],
					'File_Path'=>$simple_file_path
					
				),
				
			);
			
		}
		else{
		
			
			
			if ($Field_Line['Format']=='fs1:inline'){
				
				$curfile=explode(":",$User_Info);
				$curfileaddr=$this->nc_core->DOCUMENT_ROOT."/netcat_files/".$SID."/".$CLID."/".$curfile[0];
				
				if (!file_exists($curfileaddr)){
					return array(
						'error'=>'исходного файла не существует'
					);
				}
				
				
				
				
				copy($curfileaddr,$this->nc_core->DOCUMENT_ROOT."/netcat_files/".$SID."/".$CLID."/".$newnamefile);
				
				
				
				
				
				$parce_Field=explode(":",$User_Info);
				
				return array(
					'Simple'=>1,
					'Format'=>$Field_Line['Format'],
					'Original'=>array(
						'User_Info'=>$User_Info,
						'Field'=>'',
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/",
					),
					'Copy'=>array(
						'File_Name'=>$newnamefile,
						'File_Path'=>$SID."/".$CLID."/",
					),
					
					'Simple2'=>array(
						'User_Info'=>$Field.":".$SID."/".$CLID."/".$parce_Field[0],
						'Field'=>'',
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/"
						
					),
					'Protect'=>array(
						'User_Info'=>$User_Info,
						'Field'=>array(
							'ID' => '',
							'Real_Name' => $parce_Field[0],
							'Virt_Name' => md5($User_Info.mktime()),
							'File_Path' => "/".$SID."/".$CLID."/",
							'File_Type	' => $parce_Field[1],
							'File_Size' => $parce_Field[2] ,
							'Message_ID' => $MID,
							'Field_ID' => $Field_Line['ID'],
							'Content_Disposition' => '',
							'Download' => '',
							'Deleted' => ''
						),
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/"
						
					),
				
				);
				
				
			}
			
			
			if ($Field_Line['Format']=='fs2:inline'){
				
				
				$curfile=explode(":",$User_Info);
				
				$arr=explode("/",$curfile[3]);
				
				
				$curfileaddr=$this->nc_core->DOCUMENT_ROOT."/netcat_files/".$curfile[3];
				
				if (!file_exists($curfileaddr)){
					return array(
						'error'=>'исходного файла не существует'
					);
				}
				
				
				
				copy($curfileaddr,$this->nc_core->DOCUMENT_ROOT."/netcat_files/".$arr[0]."/".$arr[1]."/".$newnamefile);
				
				
				$parce_Field=explode(":",$User_Info);
				$parce_Field_simple=$parce_Field[0].":".$parce_Field[1].":".$parce_Field[2];
				
				return array(
					'Simple'=>2,
					'Format'=>$Field_Line['Format'],
					'Original'=>array(
						'User_Info'=>$User_Info,
						'Field'=>'',
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/",
					),
					'Copy'=>array(
						'File_Name'=>$newnamefile,
						'File_Path'=>$SID."/".$CLID."/",
					),
					
					'Simple1'=>array(
						'User_Info'=>$parce_Field_simple,
						'Field'=>'',
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/"
						
					),
					
					'Protect'=>array(
						'User_Info'=>$parce_Field_simple,
						'Field'=>array(
							'ID' => '',
							'Real_Name' =>$parce_Field[0],
							'Virt_Name' => md5($User_Info.mktime()),
							'File_Path' => "/".$SID."/".$CLID."/",
							'File_Type' => $parce_Field[1],
							'File_Size' => $parce_Field[2] ,
							'Message_ID' => $MID,
							'Field_ID' => $Field_Line['ID'],
							'Content_Disposition' => '',
							'Download' => '',
							'Deleted' => ''
						),
						'File_Name'=>$parce_Field[0],
						'File_Path'=>$SID."/".$CLID."/"
						
						
					),
				
				);
				
			}
			
			
			
		
		}
		
		
	}
	
	function action_multi($Field_Line,$User_Info,$MID,$SID,$CLID){
		
		$this->nc_core = nc_Core::get_object();
		
		$res = $this->nc_core->db->get_results("SELECT Path,Preview FROM Multifield  WHERE Field_ID=".$Field_Line['Field_ID']." AND Message_ID=".$MID."", ARRAY_A);
		
		if ($res){
			
			foreach ($res as $val){
				
				
				$newnamefile=md5(microtime());
				
				
				$old_name=explode("/",$val['Path']);
				
				$old_name=end($old_name);
				
				$path=str_replace($old_name,"",$val['Path']);
				
				
				@copy($this->nc_core->DOCUMENT_ROOT.$val['Path'],$this->nc_core->DOCUMENT_ROOT.$path.$newnamefile);
				@copy($this->nc_core->DOCUMENT_ROOT.$val['Preview'],$this->nc_core->DOCUMENT_ROOT.$path."preview_".$newnamefile);
								
				
				$return['multiply'][]=array(
				
					'Original'=>array(
						'User_Info'=>$User_Info,
						'Field'=>'',
						'File_Name'=>$old_name,
						'File_Path'=>$path,
					),
					'Copy'=>array(
						'File_Name'=>$newnamefile,
						'File_Path'=>$path,
					)
				
				);
				
			}
			
			
			return $return;
			
		}
		
	}

}




function getListComponents(){
		
		$nc_core = nc_Core::get_object();
		
		$res=$nc_core->db->get_row("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='Component_ID'",ARRAY_A);
		
		$Class_ID=$res['Value'];		
		
		
		$res = $nc_core->db->get_results("SELECT `Key`,Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='SubClass'", ARRAY_A);
		if ($res){
			foreach ($res as $val){
			
				$settings[$val['Value']]='1';
				
			}
		}
		
		
		$res = $nc_core->db->get_results("SELECT Catalogue_ID,Catalogue_Name FROM Catalogue ORDER BY Catalogue_ID", ARRAY_A);
		foreach ($res as $val){
			
			$catalogue[$val['Catalogue_ID']]=$val['Catalogue_Name'];
			
		}
		
		
		$res = $nc_core->db->get_results("SELECT Subdivision_ID,Subdivision_Name FROM Subdivision ORDER BY Subdivision_ID", ARRAY_A);
		foreach ($res as $val){
			
			$subdivision[$val['Subdivision_ID']]=$val['Subdivision_Name'];
			
		}

		$res = $nc_core->db->get_results("SELECT Catalogue_ID,Sub_Class_ID,Class_ID,Subdivision_ID, Sub_Class_Name FROM Sub_Class WHERE Class_ID<>".$Class_ID." ORDER BY Catalogue_ID,Subdivision_ID", ARRAY_A);
		
		$out="<table>
		<tr>
			<td>Раздел</td>
			<td>Компонент</td>
			<td><input type='checkbox' value='' name='select_all' id='select_all'>&nbsp;<label for='select_all' id='label_select_all'>Выделить все</label></td>
		</tr>
		";
		
		foreach ($res as $val){
			
			if ($val['Catalogue_ID']!=$curcat){
				$curcat=$val['Catalogue_ID'];
				$out.="<tr><td colspan=3><b>".$catalogue[$curcat]."</b></td></tr>";
			}
			
			$out.="<tr>";
			if ($val['Subdivision_ID']!=$cursub){
				$cursub=$val['Subdivision_ID'];
				$out.="<td>".$subdivision[$cursub]."</td>";
				$out.="<td>".$val['Sub_Class_Name']."</td>";
			}
			else{
				$out.="<td></td><td>".$val['Sub_Class_Name']."</td>";
			}
			
			
			
			$out.="<td><input type='checkbox' class='selected_subclass'  name='change[]' value='".$val['Sub_Class_ID']."' ".($settings[$val['Sub_Class_ID']]?"checked":"")."></td></tr>";
			
			
			
		}
		
		$out.="<table>";
		
		echo   $out;

}


function udateSettings($change=array()){
	
	$nc_core = nc_Core::get_object();
	
	
	$res=$nc_core->db->get_results("SELECT Sub_Class_ID,Subdivision_ID,Class_ID,Catalogue_ID FROM Sub_Class WHERE Class_ID IN (SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='Component_ID')",ARRAY_A);
	
	foreach ($res as $val)	{
		
		$Component[$val['Catalogue_ID']]=$val;
	}
	
	$Class_ID=$val['Class_ID'];
	
	
	
	$res = $nc_core->db->get_results("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='SubClass'", ARRAY_A);
	if ($res){
		foreach ($res as $val){
		
			$cur_subcl[$val['Value']]=$val['Value'];
			
		}
	}
	
	
			
	

	if (count($change)>0){
		
		$count=count($change);
		for($i=0;$i<$count;$i++){
			if ($cur_subcl[$change[$i]]){
				unset($cur_subcl[$change[$i]]);
				unset($change[$i]);
			}
		}
		
		
		
		
		
		
		if (count($cur_subcl)){
			
			$nc_core->db->query("DELETE FROM  Message".$Class_ID." WHERE SubClass IN(".implode(",",$cur_subcl).")");
			$nc_core->db->query("DELETE FROM  Settings WHERE  Module='flowofdocuments'  AND `Key`='SubClass' AND  Value IN (".implode(",",$cur_subcl).")");
			
		
		}
		
		
		if (count($change)){
			
			
			
			$arr_file =array();
			$res = $nc_core->db->get_results("SELECT Format,Field_ID,TypeOfData_ID,Field_Name,A.Class_ID Class_ID,Sub_Class_ID FROM Field A INNER JOIN Sub_Class B ON A.Class_ID = B.Class_ID WHERE Sub_Class_ID IN(".implode(',',$change).")  ORDER BY Field_ID", ARRAY_A);
			
			foreach ($res as $val){
				
				if ($val['TypeOfData_ID']==6)
					$arr_file[$val['Class_ID']][$val['Field_Name']]=$val;
				
				if ($val['TypeOfData_ID']==11)
					$arr_multi_file[$val['Class_ID']][$val['Field_Name']]=$val;

					
				$curclass[$val['Class_ID']]=$val['Class_ID'];
				$currField[$val['Class_ID']][$val['Field_Name']]=$val['Field_Name'];
				$curr_subclass[$val['Class_ID']][$val['Sub_Class_ID']]=$val['Sub_Class_ID'];
				
			}
			
			
			if (count($arr_file)||count($arr_multi_file)){
				
				$copyFile=new copyFile();
			
			}
			
			
			foreach ($curclass as $class){
				
				
				
				
				$q="
				SELECT  Message_ID, ".implode(",",$currField[$class]).",LastUser_ID,LastUserAgent,LastIP,Catalogue_ID,A.Sub_Class_ID Sub_Class_ID,A.Subdivision_ID Subdivision_ID
				FROM Message".$class." A
				INNER JOIN Sub_Class B ON A.Subdivision_ID = B.Subdivision_ID
				WHERE A.Sub_Class_ID IN (".implode(",",$curr_subclass[$class]).")
				";
				
				$res=$nc_core->db->get_results($q,ARRAY_A);
				
				if (!$res) continue;
				
				
				$q_insert=array();
				
				
				foreach ($res as $val){
					
					$Sub_Class_ID=$val['Sub_Class_ID'];
					$Catalogue_ID=$val['Catalogue_ID'];
					unset($val['Catalogue_ID']);
					
					
					foreach ($val as $k=>$v){
						
						if (!$currField[$class][$k]){
							$in['Utilities'][$k]=$v;
						}
						else{
						
							if ($arr_file[$class][$k]){
								
								if ($v)
									$v=$copyFile->action($arr_file[$class][$k],$v,$val['Message_ID'],$val['Subdivision_ID'],$Sub_Class_ID);
								else
									$v=array('msg'=>'поле пустое');
								
							}
							elseif ($arr_multi_file[$class][$k]){
								
								$v=$copyFile->action_multi($arr_multi_file[$class][$k],$v,$val['Message_ID'],$val['Subdivision_ID'],$Sub_Class_ID);
								
							}
							
							$in['User'][$k]=$v;
						}
						
					}
					
					unset($val['Sub_Class_ID']);
					
					$q_insert[]="(".$Sub_Class_ID.",\"".$nc_core->db->escape(serialize($in))."\",".$Component[$Catalogue_ID]['Sub_Class_ID'].",".$Component[$Catalogue_ID]['Subdivision_ID'].",Now())";
					
				}
				
				$nc_core->db->query("INSERT INTO Message".$Class_ID."  (SubClass,DATA,Sub_Class_ID,Subdivision_ID,Date) VALUES  ".implode(",",$q_insert)." ");
				
			}
			
		}
	
	}
	else{
		
		
		$res = $nc_core->db->get_results("SELECT DATA FROM Message".$Class_ID."", ARRAY_A);
		if ($res){
			foreach ($res as $v){
			
				$DATA=unserialize(trim($v['DATA']));
				foreach ($DATA['User'] as $curField=>$curField_Value){
					
					if (is_array($curField_Value) && !$curField_Value['msg'] && !$curField_Value['error']){
						
						if (!$curField_Value['multiply']){
							unlink($nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Copy']['File_Path'].$curField_Value['Copy']['File_Name']);
						}
						else{
							
							foreach ($curField_Value['multiply'] as $mf){
								
								unlink($nc_core->DOCUMENT_ROOT.$mf['Copy']['File_Path'].$mf['Copy']['File_Name']);
								
								
							}
						
						}
					
					}
				
				}
				
			}
			
		}
		
		$nc_core->db->query("DELETE FROM  Message".$Class_ID."");
		$nc_core->db->query("DELETE FROM  Settings WHERE  Module='flowofdocuments' AND `Key`='SubClass' ");
	
	}
	
	
	
	if (count($change)>0){
		
		$q="INSERT INTO Settings (`Key`,`Value`,`Module`)";
		
		
		foreach ($change as $k=>$v){
			$values[]="('SubClass','".$v."','flowofdocuments')";
		}
		$q.=" VALUES ".implode(",",$values);
		
		
		$nc_core->db->query($q);
		
	}
	
	return;

}









function formatFileField($to,$from,$utilites,$field_data,$DR){
				
					
	
	
	
	
	
	
	
	
	$path=explode("/",$from['Path']);
	
	if ($to['Format']=='fs3:inline'||$to['Format']=='fs3:attachment'){
		
		
		copy ($DR.$from['Path'],$DR.$to['File_Path'].$to['Virt_Name']);
		return array(
			$to['Field_Name']=>
				array(
					'Protected'=>1,
					'Path'=>$to['File_Path'].$to['Virt_Name'],
					'Filetable'=>$to,
					'Field'=>$field_data,
					
					
				)
		);
		
	}
	if ($to['Format']=='fs1:inline'||$to['Format']=='fs2:inline'){
		
		
		
		if ($from['Protected']){
		
			if ($to['Format']=='fs1:inline'){
				
				$out['Simple']=1;
				
			}
			else{
				
				$out['Simple']=2;
			
			}
			
			
			$out['Field']=$field_data;
		
		}
		
		if ($from['Simple']){
			
			if ($to['Format']=='fs1:inline'){
				
				$from['Simple']=1;
				
			}
			else{
				
				$from['Simple']=2;
			
			}
			
			return $from;
			
		}
		
		
		
		
		return array(
			$to['Field_Name']=>
				array(
					'Simple'=>1,
					'Path'=>$to['File_Path'].$to['Virt_Name'],
					'Field'=>$field_data
			)
		);
		
	}
					


}

function reestablish($ID=0){
	
	
	if ($ID<0) return;
		
	$nc_core = nc_Core::get_object();
	
	
	$res=$nc_core->db->get_row("SELECT Value FROM Settings WHERE Module='flowofdocuments' AND `Key`='Component_ID'",ARRAY_A);
	if ($res)
		$Component_ID=$res['Value'];
	
	
	$res = $nc_core->db->get_row("SELECT DATA FROM Message".$Component_ID." WHERE Message_ID=".$ID." ", ARRAY_A);
	
	
	$allUser_Fields=unserialize(trim($res['DATA']));
	
	
	
	
	foreach ($allUser_Fields['User'] as $curField=>$curField_Value){
		
		
		if (is_array($curField_Value)){
		
			if($curField_Value['multiply']){
		
				foreach ($curField_Value['multiply'] as $mf){
					
					copy($nc_core->DOCUMENT_ROOT.$mf['Copy']['File_Path'].$mf['Copy']['File_Name'],$nc_core->DOCUMENT_ROOT.$mf['Original']['File_Path'].$mf['Original']['File_Name']);
					
					$out.=$Field.":&nbsp;".($mf['msg']?$mf['msg']:"<a href='".$mf['Copy']['File_Path'].$mf['Copy']['File_Name']."'>Файл</a>")."<br>";
					
				}
				
				continue;
				
			}
			
			
			
			if ($curField_Value['msg']){
				
				
				$q[]="`".$curField."`=''";
				continue;
				
			}
			
			if ($curField_Value['error']){
				
				
				$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value['Field'])."'";
				continue;
				
			}
			
			
			
			$res=$nc_core->db->get_row("SELECT * FROM Field WHERE Field_Name='".$curField."' AND Class_ID='".$allUser_Fields['Utilities']['Class_ID']."' ", ARRAY_A);
			
			if ($res['Format']!=$v['Format']){
				
				if ($Field_Line['Format']=='fs3:inline'||$Field_Line['Format']=='fs3:attachment'){
					
					copy($nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Copy']['File_Path'].$curField_Value['Copy']['File_Name'],$nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Original']['File_Path'].$curField_Value['Protect']['Field']['Virt_Name']);
					
					
					$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value['Protect']['User_Info'])."'";
					
					
					
					
					
					
					$nc_core->db->query("
					
					UPDATE Message".$fields['Utilities']['Class_ID']." 
					
					SET 
					
					Real_Name='".$curField_Value['Protect']['Field']['Real_Name']."',
					Virt_Name='".$curField_Value['Protect']['Field']['Virt_Name']."',
					File_Path='".$curField_Value['Protect']['Field']['File_Path']."',
					File_Type='".$curField_Value['Protect']['Field']['File_Type']."',
					File_Size='".$curField_Value['Protect']['Field']['File_Size']."'
					
					WHERE 
					
					Message_ID=".$curField_Value['Protect']['Field']['Message_ID']."
					AND
					Field_ID=".$curField_Value['Protect']['Field']['Field_ID']."
					
					");
				
				}
				else if ($Field_Line['Format']=='fs1:inline'){
				
					copy($nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Copy']['File_Path'].$curField_Value['Copy']['File_Name'],$nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Original']['File_Path'].$curField_Value['Original']['File_Name']);
					$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value['Simple1']['User_Info'])."'";
					
				
				}
				elseif($Field_Line['Format']=='fs2:inline'){
					
					copy($nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Copy']['File_Path'].$curField_Value['Copy']['File_Name'],$nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Original']['File_Path'].$curField_Value['Original']['File_Name']);
					$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value['Simple2']['User_Info'])."'";
				
				}
				
			}
			else{
				
				copy($nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Copy']['File_Path'].$curField_Value['Copy']['File_Name'],$nc_core->DOCUMENT_ROOT."/netcat_files/".$curField_Value['Original']['File_Path'].$curField_Value['Original']['File_Name']);
				$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value)."'";
				
			}
			
			
		}
		
		else{
			$q[]="`".$curField."`='".mysql_real_escape_string($curField_Value)."'";
		}
	}
	
	
	$nc_core->db->query("UPDATE Message".$allUser_Fields['Utilities']['Class_ID']." SET ".implode(",",$q)." WHERE Message_ID=".$allUser_Fields['Utilities']['Message_ID']."");
		
	
}





$flowofdocuments1 = new  flowofdocuments();


?>
